// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: COState.proto

package ru.omnicomm.pegasus.messaging.online.COState;

public final class COStateParser {
  private COStateParser() {}
  public static void registerAllExtensions(
      com.google.protobuf.ExtensionRegistry registry) {
  }
  public interface COStateONOrBuilder
      extends com.google.protobuf.MessageOrBuilder {
    
    // optional int64 sourceId = 1;
    boolean hasSourceId();
    long getSourceId();
    
    // required int64 messageType = 2;
    boolean hasMessageType();
    long getMessageType();
    
    // optional int32 messageTime = 3;
    boolean hasMessageTime();
    int getMessageTime();
    
    // optional int64 timeStamp = 5;
    boolean hasTimeStamp();
    long getTimeStamp();
    
    // optional int32 messageBlock = 6;
    boolean hasMessageBlock();
    int getMessageBlock();
    
    // repeated int32 stateIds = 130;
    java.util.List<java.lang.Integer> getStateIdsList();
    int getStateIdsCount();
    int getStateIds(int index);
  }
  public static final class COStateON extends
      com.google.protobuf.GeneratedMessage
      implements COStateONOrBuilder {
    // Use COStateON.newBuilder() to construct.
    private COStateON(Builder builder) {
      super(builder);
    }
    private COStateON(boolean noInit) {}
    
    private static final COStateON defaultInstance;
    public static COStateON getDefaultInstance() {
      return defaultInstance;
    }
    
    public COStateON getDefaultInstanceForType() {
      return defaultInstance;
    }
    
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return ru.omnicomm.pegasus.messaging.online.COState.COStateParser.internal_static_ru_omnicomm_pegasus_messaging_online_COState_COStateON_descriptor;
    }
    
    protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return ru.omnicomm.pegasus.messaging.online.COState.COStateParser.internal_static_ru_omnicomm_pegasus_messaging_online_COState_COStateON_fieldAccessorTable;
    }
    
    private int bitField0_;
    // optional int64 sourceId = 1;
    public static final int SOURCEID_FIELD_NUMBER = 1;
    private long sourceId_;
    public boolean hasSourceId() {
      return ((bitField0_ & 0x00000001) == 0x00000001);
    }
    public long getSourceId() {
      return sourceId_;
    }
    
    // required int64 messageType = 2;
    public static final int MESSAGETYPE_FIELD_NUMBER = 2;
    private long messageType_;
    public boolean hasMessageType() {
      return ((bitField0_ & 0x00000002) == 0x00000002);
    }
    public long getMessageType() {
      return messageType_;
    }
    
    // optional int32 messageTime = 3;
    public static final int MESSAGETIME_FIELD_NUMBER = 3;
    private int messageTime_;
    public boolean hasMessageTime() {
      return ((bitField0_ & 0x00000004) == 0x00000004);
    }
    public int getMessageTime() {
      return messageTime_;
    }
    
    // optional int64 timeStamp = 5;
    public static final int TIMESTAMP_FIELD_NUMBER = 5;
    private long timeStamp_;
    public boolean hasTimeStamp() {
      return ((bitField0_ & 0x00000008) == 0x00000008);
    }
    public long getTimeStamp() {
      return timeStamp_;
    }
    
    // optional int32 messageBlock = 6;
    public static final int MESSAGEBLOCK_FIELD_NUMBER = 6;
    private int messageBlock_;
    public boolean hasMessageBlock() {
      return ((bitField0_ & 0x00000010) == 0x00000010);
    }
    public int getMessageBlock() {
      return messageBlock_;
    }
    
    // repeated int32 stateIds = 130;
    public static final int STATEIDS_FIELD_NUMBER = 130;
    private java.util.List<java.lang.Integer> stateIds_;
    public java.util.List<java.lang.Integer>
        getStateIdsList() {
      return stateIds_;
    }
    public int getStateIdsCount() {
      return stateIds_.size();
    }
    public int getStateIds(int index) {
      return stateIds_.get(index);
    }
    
    private void initFields() {
      sourceId_ = 0L;
      messageType_ = 0L;
      messageTime_ = 0;
      timeStamp_ = 0L;
      messageBlock_ = 0;
      stateIds_ = java.util.Collections.emptyList();;
    }
    private byte memoizedIsInitialized = -1;
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized != -1) return isInitialized == 1;
      
      if (!hasMessageType()) {
        memoizedIsInitialized = 0;
        return false;
      }
      memoizedIsInitialized = 1;
      return true;
    }
    
    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      getSerializedSize();
      if (((bitField0_ & 0x00000001) == 0x00000001)) {
        output.writeInt64(1, sourceId_);
      }
      if (((bitField0_ & 0x00000002) == 0x00000002)) {
        output.writeInt64(2, messageType_);
      }
      if (((bitField0_ & 0x00000004) == 0x00000004)) {
        output.writeInt32(3, messageTime_);
      }
      if (((bitField0_ & 0x00000008) == 0x00000008)) {
        output.writeInt64(5, timeStamp_);
      }
      if (((bitField0_ & 0x00000010) == 0x00000010)) {
        output.writeInt32(6, messageBlock_);
      }
      for (int i = 0; i < stateIds_.size(); i++) {
        output.writeInt32(130, stateIds_.get(i));
      }
      getUnknownFields().writeTo(output);
    }
    
    private int memoizedSerializedSize = -1;
    public int getSerializedSize() {
      int size = memoizedSerializedSize;
      if (size != -1) return size;
    
      size = 0;
      if (((bitField0_ & 0x00000001) == 0x00000001)) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt64Size(1, sourceId_);
      }
      if (((bitField0_ & 0x00000002) == 0x00000002)) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt64Size(2, messageType_);
      }
      if (((bitField0_ & 0x00000004) == 0x00000004)) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(3, messageTime_);
      }
      if (((bitField0_ & 0x00000008) == 0x00000008)) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt64Size(5, timeStamp_);
      }
      if (((bitField0_ & 0x00000010) == 0x00000010)) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(6, messageBlock_);
      }
      {
        int dataSize = 0;
        for (int i = 0; i < stateIds_.size(); i++) {
          dataSize += com.google.protobuf.CodedOutputStream
            .computeInt32SizeNoTag(stateIds_.get(i));
        }
        size += dataSize;
        size += 2 * getStateIdsList().size();
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSerializedSize = size;
      return size;
    }
    
    private static final long serialVersionUID = 0L;
    @java.lang.Override
    protected java.lang.Object writeReplace()
        throws java.io.ObjectStreamException {
      return super.writeReplace();
    }
    
    public static ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateON parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateON parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data, extensionRegistry)
               .buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateON parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateON parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data, extensionRegistry)
               .buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateON parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateON parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input, extensionRegistry)
               .buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateON parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      Builder builder = newBuilder();
      if (builder.mergeDelimitedFrom(input)) {
        return builder.buildParsed();
      } else {
        return null;
      }
    }
    public static ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateON parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      Builder builder = newBuilder();
      if (builder.mergeDelimitedFrom(input, extensionRegistry)) {
        return builder.buildParsed();
      } else {
        return null;
      }
    }
    public static ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateON parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateON parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input, extensionRegistry)
               .buildParsed();
    }
    
    public static Builder newBuilder() { return Builder.create(); }
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder(ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateON prototype) {
      return newBuilder().mergeFrom(prototype);
    }
    public Builder toBuilder() { return newBuilder(this); }
    
    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessage.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    public static final class Builder extends
        com.google.protobuf.GeneratedMessage.Builder<Builder>
       implements ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateONOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return ru.omnicomm.pegasus.messaging.online.COState.COStateParser.internal_static_ru_omnicomm_pegasus_messaging_online_COState_COStateON_descriptor;
      }
      
      protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return ru.omnicomm.pegasus.messaging.online.COState.COStateParser.internal_static_ru_omnicomm_pegasus_messaging_online_COState_COStateON_fieldAccessorTable;
      }
      
      // Construct using ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateON.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }
      
      private Builder(BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }
      private void maybeForceBuilderInitialization() {
        if (com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders) {
        }
      }
      private static Builder create() {
        return new Builder();
      }
      
      public Builder clear() {
        super.clear();
        sourceId_ = 0L;
        bitField0_ = (bitField0_ & ~0x00000001);
        messageType_ = 0L;
        bitField0_ = (bitField0_ & ~0x00000002);
        messageTime_ = 0;
        bitField0_ = (bitField0_ & ~0x00000004);
        timeStamp_ = 0L;
        bitField0_ = (bitField0_ & ~0x00000008);
        messageBlock_ = 0;
        bitField0_ = (bitField0_ & ~0x00000010);
        stateIds_ = java.util.Collections.emptyList();;
        bitField0_ = (bitField0_ & ~0x00000020);
        return this;
      }
      
      public Builder clone() {
        return create().mergeFrom(buildPartial());
      }
      
      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateON.getDescriptor();
      }
      
      public ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateON getDefaultInstanceForType() {
        return ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateON.getDefaultInstance();
      }
      
      public ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateON build() {
        ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateON result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }
      
      private ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateON buildParsed()
          throws com.google.protobuf.InvalidProtocolBufferException {
        ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateON result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(
            result).asInvalidProtocolBufferException();
        }
        return result;
      }
      
      public ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateON buildPartial() {
        ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateON result = new ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateON(this);
        int from_bitField0_ = bitField0_;
        int to_bitField0_ = 0;
        if (((from_bitField0_ & 0x00000001) == 0x00000001)) {
          to_bitField0_ |= 0x00000001;
        }
        result.sourceId_ = sourceId_;
        if (((from_bitField0_ & 0x00000002) == 0x00000002)) {
          to_bitField0_ |= 0x00000002;
        }
        result.messageType_ = messageType_;
        if (((from_bitField0_ & 0x00000004) == 0x00000004)) {
          to_bitField0_ |= 0x00000004;
        }
        result.messageTime_ = messageTime_;
        if (((from_bitField0_ & 0x00000008) == 0x00000008)) {
          to_bitField0_ |= 0x00000008;
        }
        result.timeStamp_ = timeStamp_;
        if (((from_bitField0_ & 0x00000010) == 0x00000010)) {
          to_bitField0_ |= 0x00000010;
        }
        result.messageBlock_ = messageBlock_;
        if (((bitField0_ & 0x00000020) == 0x00000020)) {
          stateIds_ = java.util.Collections.unmodifiableList(stateIds_);
          bitField0_ = (bitField0_ & ~0x00000020);
        }
        result.stateIds_ = stateIds_;
        result.bitField0_ = to_bitField0_;
        onBuilt();
        return result;
      }
      
      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateON) {
          return mergeFrom((ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateON)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }
      
      public Builder mergeFrom(ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateON other) {
        if (other == ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateON.getDefaultInstance()) return this;
        if (other.hasSourceId()) {
          setSourceId(other.getSourceId());
        }
        if (other.hasMessageType()) {
          setMessageType(other.getMessageType());
        }
        if (other.hasMessageTime()) {
          setMessageTime(other.getMessageTime());
        }
        if (other.hasTimeStamp()) {
          setTimeStamp(other.getTimeStamp());
        }
        if (other.hasMessageBlock()) {
          setMessageBlock(other.getMessageBlock());
        }
        if (!other.stateIds_.isEmpty()) {
          if (stateIds_.isEmpty()) {
            stateIds_ = other.stateIds_;
            bitField0_ = (bitField0_ & ~0x00000020);
          } else {
            ensureStateIdsIsMutable();
            stateIds_.addAll(other.stateIds_);
          }
          onChanged();
        }
        this.mergeUnknownFields(other.getUnknownFields());
        return this;
      }
      
      public final boolean isInitialized() {
        if (!hasMessageType()) {
          
          return false;
        }
        return true;
      }
      
      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        com.google.protobuf.UnknownFieldSet.Builder unknownFields =
          com.google.protobuf.UnknownFieldSet.newBuilder(
            this.getUnknownFields());
        while (true) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              this.setUnknownFields(unknownFields.build());
              onChanged();
              return this;
            default: {
              if (!parseUnknownField(input, unknownFields,
                                     extensionRegistry, tag)) {
                this.setUnknownFields(unknownFields.build());
                onChanged();
                return this;
              }
              break;
            }
            case 8: {
              bitField0_ |= 0x00000001;
              sourceId_ = input.readInt64();
              break;
            }
            case 16: {
              bitField0_ |= 0x00000002;
              messageType_ = input.readInt64();
              break;
            }
            case 24: {
              bitField0_ |= 0x00000004;
              messageTime_ = input.readInt32();
              break;
            }
            case 40: {
              bitField0_ |= 0x00000008;
              timeStamp_ = input.readInt64();
              break;
            }
            case 48: {
              bitField0_ |= 0x00000010;
              messageBlock_ = input.readInt32();
              break;
            }
            case 1040: {
              ensureStateIdsIsMutable();
              stateIds_.add(input.readInt32());
              break;
            }
            case 1042: {
              int length = input.readRawVarint32();
              int limit = input.pushLimit(length);
              while (input.getBytesUntilLimit() > 0) {
                addStateIds(input.readInt32());
              }
              input.popLimit(limit);
              break;
            }
          }
        }
      }
      
      private int bitField0_;
      
      // optional int64 sourceId = 1;
      private long sourceId_ ;
      public boolean hasSourceId() {
        return ((bitField0_ & 0x00000001) == 0x00000001);
      }
      public long getSourceId() {
        return sourceId_;
      }
      public Builder setSourceId(long value) {
        bitField0_ |= 0x00000001;
        sourceId_ = value;
        onChanged();
        return this;
      }
      public Builder clearSourceId() {
        bitField0_ = (bitField0_ & ~0x00000001);
        sourceId_ = 0L;
        onChanged();
        return this;
      }
      
      // required int64 messageType = 2;
      private long messageType_ ;
      public boolean hasMessageType() {
        return ((bitField0_ & 0x00000002) == 0x00000002);
      }
      public long getMessageType() {
        return messageType_;
      }
      public Builder setMessageType(long value) {
        bitField0_ |= 0x00000002;
        messageType_ = value;
        onChanged();
        return this;
      }
      public Builder clearMessageType() {
        bitField0_ = (bitField0_ & ~0x00000002);
        messageType_ = 0L;
        onChanged();
        return this;
      }
      
      // optional int32 messageTime = 3;
      private int messageTime_ ;
      public boolean hasMessageTime() {
        return ((bitField0_ & 0x00000004) == 0x00000004);
      }
      public int getMessageTime() {
        return messageTime_;
      }
      public Builder setMessageTime(int value) {
        bitField0_ |= 0x00000004;
        messageTime_ = value;
        onChanged();
        return this;
      }
      public Builder clearMessageTime() {
        bitField0_ = (bitField0_ & ~0x00000004);
        messageTime_ = 0;
        onChanged();
        return this;
      }
      
      // optional int64 timeStamp = 5;
      private long timeStamp_ ;
      public boolean hasTimeStamp() {
        return ((bitField0_ & 0x00000008) == 0x00000008);
      }
      public long getTimeStamp() {
        return timeStamp_;
      }
      public Builder setTimeStamp(long value) {
        bitField0_ |= 0x00000008;
        timeStamp_ = value;
        onChanged();
        return this;
      }
      public Builder clearTimeStamp() {
        bitField0_ = (bitField0_ & ~0x00000008);
        timeStamp_ = 0L;
        onChanged();
        return this;
      }
      
      // optional int32 messageBlock = 6;
      private int messageBlock_ ;
      public boolean hasMessageBlock() {
        return ((bitField0_ & 0x00000010) == 0x00000010);
      }
      public int getMessageBlock() {
        return messageBlock_;
      }
      public Builder setMessageBlock(int value) {
        bitField0_ |= 0x00000010;
        messageBlock_ = value;
        onChanged();
        return this;
      }
      public Builder clearMessageBlock() {
        bitField0_ = (bitField0_ & ~0x00000010);
        messageBlock_ = 0;
        onChanged();
        return this;
      }
      
      // repeated int32 stateIds = 130;
      private java.util.List<java.lang.Integer> stateIds_ = java.util.Collections.emptyList();;
      private void ensureStateIdsIsMutable() {
        if (!((bitField0_ & 0x00000020) == 0x00000020)) {
          stateIds_ = new java.util.ArrayList<java.lang.Integer>(stateIds_);
          bitField0_ |= 0x00000020;
         }
      }
      public java.util.List<java.lang.Integer>
          getStateIdsList() {
        return java.util.Collections.unmodifiableList(stateIds_);
      }
      public int getStateIdsCount() {
        return stateIds_.size();
      }
      public int getStateIds(int index) {
        return stateIds_.get(index);
      }
      public Builder setStateIds(
          int index, int value) {
        ensureStateIdsIsMutable();
        stateIds_.set(index, value);
        onChanged();
        return this;
      }
      public Builder addStateIds(int value) {
        ensureStateIdsIsMutable();
        stateIds_.add(value);
        onChanged();
        return this;
      }
      public Builder addAllStateIds(
          java.lang.Iterable<? extends java.lang.Integer> values) {
        ensureStateIdsIsMutable();
        super.addAll(values, stateIds_);
        onChanged();
        return this;
      }
      public Builder clearStateIds() {
        stateIds_ = java.util.Collections.emptyList();;
        bitField0_ = (bitField0_ & ~0x00000020);
        onChanged();
        return this;
      }
      
      // @@protoc_insertion_point(builder_scope:ru.omnicomm.pegasus.messaging.online.COState.COStateON)
    }
    
    static {
      defaultInstance = new COStateON(true);
      defaultInstance.initFields();
    }
    
    // @@protoc_insertion_point(class_scope:ru.omnicomm.pegasus.messaging.online.COState.COStateON)
  }
  
  public interface COStateOFFOrBuilder
      extends com.google.protobuf.MessageOrBuilder {
    
    // optional int64 sourceId = 1;
    boolean hasSourceId();
    long getSourceId();
    
    // required int64 messageType = 2;
    boolean hasMessageType();
    long getMessageType();
    
    // optional int32 messageTime = 3;
    boolean hasMessageTime();
    int getMessageTime();
    
    // optional int64 timeStamp = 5;
    boolean hasTimeStamp();
    long getTimeStamp();
    
    // optional int32 messageBlock = 6;
    boolean hasMessageBlock();
    int getMessageBlock();
    
    // repeated int32 stateIds = 130;
    java.util.List<java.lang.Integer> getStateIdsList();
    int getStateIdsCount();
    int getStateIds(int index);
  }
  public static final class COStateOFF extends
      com.google.protobuf.GeneratedMessage
      implements COStateOFFOrBuilder {
    // Use COStateOFF.newBuilder() to construct.
    private COStateOFF(Builder builder) {
      super(builder);
    }
    private COStateOFF(boolean noInit) {}
    
    private static final COStateOFF defaultInstance;
    public static COStateOFF getDefaultInstance() {
      return defaultInstance;
    }
    
    public COStateOFF getDefaultInstanceForType() {
      return defaultInstance;
    }
    
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return ru.omnicomm.pegasus.messaging.online.COState.COStateParser.internal_static_ru_omnicomm_pegasus_messaging_online_COState_COStateOFF_descriptor;
    }
    
    protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return ru.omnicomm.pegasus.messaging.online.COState.COStateParser.internal_static_ru_omnicomm_pegasus_messaging_online_COState_COStateOFF_fieldAccessorTable;
    }
    
    private int bitField0_;
    // optional int64 sourceId = 1;
    public static final int SOURCEID_FIELD_NUMBER = 1;
    private long sourceId_;
    public boolean hasSourceId() {
      return ((bitField0_ & 0x00000001) == 0x00000001);
    }
    public long getSourceId() {
      return sourceId_;
    }
    
    // required int64 messageType = 2;
    public static final int MESSAGETYPE_FIELD_NUMBER = 2;
    private long messageType_;
    public boolean hasMessageType() {
      return ((bitField0_ & 0x00000002) == 0x00000002);
    }
    public long getMessageType() {
      return messageType_;
    }
    
    // optional int32 messageTime = 3;
    public static final int MESSAGETIME_FIELD_NUMBER = 3;
    private int messageTime_;
    public boolean hasMessageTime() {
      return ((bitField0_ & 0x00000004) == 0x00000004);
    }
    public int getMessageTime() {
      return messageTime_;
    }
    
    // optional int64 timeStamp = 5;
    public static final int TIMESTAMP_FIELD_NUMBER = 5;
    private long timeStamp_;
    public boolean hasTimeStamp() {
      return ((bitField0_ & 0x00000008) == 0x00000008);
    }
    public long getTimeStamp() {
      return timeStamp_;
    }
    
    // optional int32 messageBlock = 6;
    public static final int MESSAGEBLOCK_FIELD_NUMBER = 6;
    private int messageBlock_;
    public boolean hasMessageBlock() {
      return ((bitField0_ & 0x00000010) == 0x00000010);
    }
    public int getMessageBlock() {
      return messageBlock_;
    }
    
    // repeated int32 stateIds = 130;
    public static final int STATEIDS_FIELD_NUMBER = 130;
    private java.util.List<java.lang.Integer> stateIds_;
    public java.util.List<java.lang.Integer>
        getStateIdsList() {
      return stateIds_;
    }
    public int getStateIdsCount() {
      return stateIds_.size();
    }
    public int getStateIds(int index) {
      return stateIds_.get(index);
    }
    
    private void initFields() {
      sourceId_ = 0L;
      messageType_ = 0L;
      messageTime_ = 0;
      timeStamp_ = 0L;
      messageBlock_ = 0;
      stateIds_ = java.util.Collections.emptyList();;
    }
    private byte memoizedIsInitialized = -1;
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized != -1) return isInitialized == 1;
      
      if (!hasMessageType()) {
        memoizedIsInitialized = 0;
        return false;
      }
      memoizedIsInitialized = 1;
      return true;
    }
    
    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      getSerializedSize();
      if (((bitField0_ & 0x00000001) == 0x00000001)) {
        output.writeInt64(1, sourceId_);
      }
      if (((bitField0_ & 0x00000002) == 0x00000002)) {
        output.writeInt64(2, messageType_);
      }
      if (((bitField0_ & 0x00000004) == 0x00000004)) {
        output.writeInt32(3, messageTime_);
      }
      if (((bitField0_ & 0x00000008) == 0x00000008)) {
        output.writeInt64(5, timeStamp_);
      }
      if (((bitField0_ & 0x00000010) == 0x00000010)) {
        output.writeInt32(6, messageBlock_);
      }
      for (int i = 0; i < stateIds_.size(); i++) {
        output.writeInt32(130, stateIds_.get(i));
      }
      getUnknownFields().writeTo(output);
    }
    
    private int memoizedSerializedSize = -1;
    public int getSerializedSize() {
      int size = memoizedSerializedSize;
      if (size != -1) return size;
    
      size = 0;
      if (((bitField0_ & 0x00000001) == 0x00000001)) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt64Size(1, sourceId_);
      }
      if (((bitField0_ & 0x00000002) == 0x00000002)) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt64Size(2, messageType_);
      }
      if (((bitField0_ & 0x00000004) == 0x00000004)) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(3, messageTime_);
      }
      if (((bitField0_ & 0x00000008) == 0x00000008)) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt64Size(5, timeStamp_);
      }
      if (((bitField0_ & 0x00000010) == 0x00000010)) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(6, messageBlock_);
      }
      {
        int dataSize = 0;
        for (int i = 0; i < stateIds_.size(); i++) {
          dataSize += com.google.protobuf.CodedOutputStream
            .computeInt32SizeNoTag(stateIds_.get(i));
        }
        size += dataSize;
        size += 2 * getStateIdsList().size();
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSerializedSize = size;
      return size;
    }
    
    private static final long serialVersionUID = 0L;
    @java.lang.Override
    protected java.lang.Object writeReplace()
        throws java.io.ObjectStreamException {
      return super.writeReplace();
    }
    
    public static ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateOFF parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateOFF parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data, extensionRegistry)
               .buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateOFF parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateOFF parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data, extensionRegistry)
               .buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateOFF parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateOFF parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input, extensionRegistry)
               .buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateOFF parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      Builder builder = newBuilder();
      if (builder.mergeDelimitedFrom(input)) {
        return builder.buildParsed();
      } else {
        return null;
      }
    }
    public static ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateOFF parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      Builder builder = newBuilder();
      if (builder.mergeDelimitedFrom(input, extensionRegistry)) {
        return builder.buildParsed();
      } else {
        return null;
      }
    }
    public static ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateOFF parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateOFF parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input, extensionRegistry)
               .buildParsed();
    }
    
    public static Builder newBuilder() { return Builder.create(); }
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder(ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateOFF prototype) {
      return newBuilder().mergeFrom(prototype);
    }
    public Builder toBuilder() { return newBuilder(this); }
    
    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessage.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    public static final class Builder extends
        com.google.protobuf.GeneratedMessage.Builder<Builder>
       implements ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateOFFOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return ru.omnicomm.pegasus.messaging.online.COState.COStateParser.internal_static_ru_omnicomm_pegasus_messaging_online_COState_COStateOFF_descriptor;
      }
      
      protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return ru.omnicomm.pegasus.messaging.online.COState.COStateParser.internal_static_ru_omnicomm_pegasus_messaging_online_COState_COStateOFF_fieldAccessorTable;
      }
      
      // Construct using ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateOFF.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }
      
      private Builder(BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }
      private void maybeForceBuilderInitialization() {
        if (com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders) {
        }
      }
      private static Builder create() {
        return new Builder();
      }
      
      public Builder clear() {
        super.clear();
        sourceId_ = 0L;
        bitField0_ = (bitField0_ & ~0x00000001);
        messageType_ = 0L;
        bitField0_ = (bitField0_ & ~0x00000002);
        messageTime_ = 0;
        bitField0_ = (bitField0_ & ~0x00000004);
        timeStamp_ = 0L;
        bitField0_ = (bitField0_ & ~0x00000008);
        messageBlock_ = 0;
        bitField0_ = (bitField0_ & ~0x00000010);
        stateIds_ = java.util.Collections.emptyList();;
        bitField0_ = (bitField0_ & ~0x00000020);
        return this;
      }
      
      public Builder clone() {
        return create().mergeFrom(buildPartial());
      }
      
      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateOFF.getDescriptor();
      }
      
      public ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateOFF getDefaultInstanceForType() {
        return ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateOFF.getDefaultInstance();
      }
      
      public ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateOFF build() {
        ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateOFF result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }
      
      private ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateOFF buildParsed()
          throws com.google.protobuf.InvalidProtocolBufferException {
        ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateOFF result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(
            result).asInvalidProtocolBufferException();
        }
        return result;
      }
      
      public ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateOFF buildPartial() {
        ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateOFF result = new ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateOFF(this);
        int from_bitField0_ = bitField0_;
        int to_bitField0_ = 0;
        if (((from_bitField0_ & 0x00000001) == 0x00000001)) {
          to_bitField0_ |= 0x00000001;
        }
        result.sourceId_ = sourceId_;
        if (((from_bitField0_ & 0x00000002) == 0x00000002)) {
          to_bitField0_ |= 0x00000002;
        }
        result.messageType_ = messageType_;
        if (((from_bitField0_ & 0x00000004) == 0x00000004)) {
          to_bitField0_ |= 0x00000004;
        }
        result.messageTime_ = messageTime_;
        if (((from_bitField0_ & 0x00000008) == 0x00000008)) {
          to_bitField0_ |= 0x00000008;
        }
        result.timeStamp_ = timeStamp_;
        if (((from_bitField0_ & 0x00000010) == 0x00000010)) {
          to_bitField0_ |= 0x00000010;
        }
        result.messageBlock_ = messageBlock_;
        if (((bitField0_ & 0x00000020) == 0x00000020)) {
          stateIds_ = java.util.Collections.unmodifiableList(stateIds_);
          bitField0_ = (bitField0_ & ~0x00000020);
        }
        result.stateIds_ = stateIds_;
        result.bitField0_ = to_bitField0_;
        onBuilt();
        return result;
      }
      
      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateOFF) {
          return mergeFrom((ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateOFF)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }
      
      public Builder mergeFrom(ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateOFF other) {
        if (other == ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateOFF.getDefaultInstance()) return this;
        if (other.hasSourceId()) {
          setSourceId(other.getSourceId());
        }
        if (other.hasMessageType()) {
          setMessageType(other.getMessageType());
        }
        if (other.hasMessageTime()) {
          setMessageTime(other.getMessageTime());
        }
        if (other.hasTimeStamp()) {
          setTimeStamp(other.getTimeStamp());
        }
        if (other.hasMessageBlock()) {
          setMessageBlock(other.getMessageBlock());
        }
        if (!other.stateIds_.isEmpty()) {
          if (stateIds_.isEmpty()) {
            stateIds_ = other.stateIds_;
            bitField0_ = (bitField0_ & ~0x00000020);
          } else {
            ensureStateIdsIsMutable();
            stateIds_.addAll(other.stateIds_);
          }
          onChanged();
        }
        this.mergeUnknownFields(other.getUnknownFields());
        return this;
      }
      
      public final boolean isInitialized() {
        if (!hasMessageType()) {
          
          return false;
        }
        return true;
      }
      
      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        com.google.protobuf.UnknownFieldSet.Builder unknownFields =
          com.google.protobuf.UnknownFieldSet.newBuilder(
            this.getUnknownFields());
        while (true) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              this.setUnknownFields(unknownFields.build());
              onChanged();
              return this;
            default: {
              if (!parseUnknownField(input, unknownFields,
                                     extensionRegistry, tag)) {
                this.setUnknownFields(unknownFields.build());
                onChanged();
                return this;
              }
              break;
            }
            case 8: {
              bitField0_ |= 0x00000001;
              sourceId_ = input.readInt64();
              break;
            }
            case 16: {
              bitField0_ |= 0x00000002;
              messageType_ = input.readInt64();
              break;
            }
            case 24: {
              bitField0_ |= 0x00000004;
              messageTime_ = input.readInt32();
              break;
            }
            case 40: {
              bitField0_ |= 0x00000008;
              timeStamp_ = input.readInt64();
              break;
            }
            case 48: {
              bitField0_ |= 0x00000010;
              messageBlock_ = input.readInt32();
              break;
            }
            case 1040: {
              ensureStateIdsIsMutable();
              stateIds_.add(input.readInt32());
              break;
            }
            case 1042: {
              int length = input.readRawVarint32();
              int limit = input.pushLimit(length);
              while (input.getBytesUntilLimit() > 0) {
                addStateIds(input.readInt32());
              }
              input.popLimit(limit);
              break;
            }
          }
        }
      }
      
      private int bitField0_;
      
      // optional int64 sourceId = 1;
      private long sourceId_ ;
      public boolean hasSourceId() {
        return ((bitField0_ & 0x00000001) == 0x00000001);
      }
      public long getSourceId() {
        return sourceId_;
      }
      public Builder setSourceId(long value) {
        bitField0_ |= 0x00000001;
        sourceId_ = value;
        onChanged();
        return this;
      }
      public Builder clearSourceId() {
        bitField0_ = (bitField0_ & ~0x00000001);
        sourceId_ = 0L;
        onChanged();
        return this;
      }
      
      // required int64 messageType = 2;
      private long messageType_ ;
      public boolean hasMessageType() {
        return ((bitField0_ & 0x00000002) == 0x00000002);
      }
      public long getMessageType() {
        return messageType_;
      }
      public Builder setMessageType(long value) {
        bitField0_ |= 0x00000002;
        messageType_ = value;
        onChanged();
        return this;
      }
      public Builder clearMessageType() {
        bitField0_ = (bitField0_ & ~0x00000002);
        messageType_ = 0L;
        onChanged();
        return this;
      }
      
      // optional int32 messageTime = 3;
      private int messageTime_ ;
      public boolean hasMessageTime() {
        return ((bitField0_ & 0x00000004) == 0x00000004);
      }
      public int getMessageTime() {
        return messageTime_;
      }
      public Builder setMessageTime(int value) {
        bitField0_ |= 0x00000004;
        messageTime_ = value;
        onChanged();
        return this;
      }
      public Builder clearMessageTime() {
        bitField0_ = (bitField0_ & ~0x00000004);
        messageTime_ = 0;
        onChanged();
        return this;
      }
      
      // optional int64 timeStamp = 5;
      private long timeStamp_ ;
      public boolean hasTimeStamp() {
        return ((bitField0_ & 0x00000008) == 0x00000008);
      }
      public long getTimeStamp() {
        return timeStamp_;
      }
      public Builder setTimeStamp(long value) {
        bitField0_ |= 0x00000008;
        timeStamp_ = value;
        onChanged();
        return this;
      }
      public Builder clearTimeStamp() {
        bitField0_ = (bitField0_ & ~0x00000008);
        timeStamp_ = 0L;
        onChanged();
        return this;
      }
      
      // optional int32 messageBlock = 6;
      private int messageBlock_ ;
      public boolean hasMessageBlock() {
        return ((bitField0_ & 0x00000010) == 0x00000010);
      }
      public int getMessageBlock() {
        return messageBlock_;
      }
      public Builder setMessageBlock(int value) {
        bitField0_ |= 0x00000010;
        messageBlock_ = value;
        onChanged();
        return this;
      }
      public Builder clearMessageBlock() {
        bitField0_ = (bitField0_ & ~0x00000010);
        messageBlock_ = 0;
        onChanged();
        return this;
      }
      
      // repeated int32 stateIds = 130;
      private java.util.List<java.lang.Integer> stateIds_ = java.util.Collections.emptyList();;
      private void ensureStateIdsIsMutable() {
        if (!((bitField0_ & 0x00000020) == 0x00000020)) {
          stateIds_ = new java.util.ArrayList<java.lang.Integer>(stateIds_);
          bitField0_ |= 0x00000020;
         }
      }
      public java.util.List<java.lang.Integer>
          getStateIdsList() {
        return java.util.Collections.unmodifiableList(stateIds_);
      }
      public int getStateIdsCount() {
        return stateIds_.size();
      }
      public int getStateIds(int index) {
        return stateIds_.get(index);
      }
      public Builder setStateIds(
          int index, int value) {
        ensureStateIdsIsMutable();
        stateIds_.set(index, value);
        onChanged();
        return this;
      }
      public Builder addStateIds(int value) {
        ensureStateIdsIsMutable();
        stateIds_.add(value);
        onChanged();
        return this;
      }
      public Builder addAllStateIds(
          java.lang.Iterable<? extends java.lang.Integer> values) {
        ensureStateIdsIsMutable();
        super.addAll(values, stateIds_);
        onChanged();
        return this;
      }
      public Builder clearStateIds() {
        stateIds_ = java.util.Collections.emptyList();;
        bitField0_ = (bitField0_ & ~0x00000020);
        onChanged();
        return this;
      }
      
      // @@protoc_insertion_point(builder_scope:ru.omnicomm.pegasus.messaging.online.COState.COStateOFF)
    }
    
    static {
      defaultInstance = new COStateOFF(true);
      defaultInstance.initFields();
    }
    
    // @@protoc_insertion_point(class_scope:ru.omnicomm.pegasus.messaging.online.COState.COStateOFF)
  }
  
  public interface COStateFailureOrBuilder
      extends com.google.protobuf.MessageOrBuilder {
    
    // optional int64 sourceId = 1;
    boolean hasSourceId();
    long getSourceId();
    
    // required int64 messageType = 2;
    boolean hasMessageType();
    long getMessageType();
    
    // optional int32 messageTime = 3;
    boolean hasMessageTime();
    int getMessageTime();
    
    // optional int64 timeStamp = 5;
    boolean hasTimeStamp();
    long getTimeStamp();
    
    // optional int32 messageBlock = 6;
    boolean hasMessageBlock();
    int getMessageBlock();
    
    // optional int32 errorCode = 131;
    boolean hasErrorCode();
    int getErrorCode();
  }
  public static final class COStateFailure extends
      com.google.protobuf.GeneratedMessage
      implements COStateFailureOrBuilder {
    // Use COStateFailure.newBuilder() to construct.
    private COStateFailure(Builder builder) {
      super(builder);
    }
    private COStateFailure(boolean noInit) {}
    
    private static final COStateFailure defaultInstance;
    public static COStateFailure getDefaultInstance() {
      return defaultInstance;
    }
    
    public COStateFailure getDefaultInstanceForType() {
      return defaultInstance;
    }
    
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return ru.omnicomm.pegasus.messaging.online.COState.COStateParser.internal_static_ru_omnicomm_pegasus_messaging_online_COState_COStateFailure_descriptor;
    }
    
    protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return ru.omnicomm.pegasus.messaging.online.COState.COStateParser.internal_static_ru_omnicomm_pegasus_messaging_online_COState_COStateFailure_fieldAccessorTable;
    }
    
    private int bitField0_;
    // optional int64 sourceId = 1;
    public static final int SOURCEID_FIELD_NUMBER = 1;
    private long sourceId_;
    public boolean hasSourceId() {
      return ((bitField0_ & 0x00000001) == 0x00000001);
    }
    public long getSourceId() {
      return sourceId_;
    }
    
    // required int64 messageType = 2;
    public static final int MESSAGETYPE_FIELD_NUMBER = 2;
    private long messageType_;
    public boolean hasMessageType() {
      return ((bitField0_ & 0x00000002) == 0x00000002);
    }
    public long getMessageType() {
      return messageType_;
    }
    
    // optional int32 messageTime = 3;
    public static final int MESSAGETIME_FIELD_NUMBER = 3;
    private int messageTime_;
    public boolean hasMessageTime() {
      return ((bitField0_ & 0x00000004) == 0x00000004);
    }
    public int getMessageTime() {
      return messageTime_;
    }
    
    // optional int64 timeStamp = 5;
    public static final int TIMESTAMP_FIELD_NUMBER = 5;
    private long timeStamp_;
    public boolean hasTimeStamp() {
      return ((bitField0_ & 0x00000008) == 0x00000008);
    }
    public long getTimeStamp() {
      return timeStamp_;
    }
    
    // optional int32 messageBlock = 6;
    public static final int MESSAGEBLOCK_FIELD_NUMBER = 6;
    private int messageBlock_;
    public boolean hasMessageBlock() {
      return ((bitField0_ & 0x00000010) == 0x00000010);
    }
    public int getMessageBlock() {
      return messageBlock_;
    }
    
    // optional int32 errorCode = 131;
    public static final int ERRORCODE_FIELD_NUMBER = 131;
    private int errorCode_;
    public boolean hasErrorCode() {
      return ((bitField0_ & 0x00000020) == 0x00000020);
    }
    public int getErrorCode() {
      return errorCode_;
    }
    
    private void initFields() {
      sourceId_ = 0L;
      messageType_ = 0L;
      messageTime_ = 0;
      timeStamp_ = 0L;
      messageBlock_ = 0;
      errorCode_ = 0;
    }
    private byte memoizedIsInitialized = -1;
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized != -1) return isInitialized == 1;
      
      if (!hasMessageType()) {
        memoizedIsInitialized = 0;
        return false;
      }
      memoizedIsInitialized = 1;
      return true;
    }
    
    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      getSerializedSize();
      if (((bitField0_ & 0x00000001) == 0x00000001)) {
        output.writeInt64(1, sourceId_);
      }
      if (((bitField0_ & 0x00000002) == 0x00000002)) {
        output.writeInt64(2, messageType_);
      }
      if (((bitField0_ & 0x00000004) == 0x00000004)) {
        output.writeInt32(3, messageTime_);
      }
      if (((bitField0_ & 0x00000008) == 0x00000008)) {
        output.writeInt64(5, timeStamp_);
      }
      if (((bitField0_ & 0x00000010) == 0x00000010)) {
        output.writeInt32(6, messageBlock_);
      }
      if (((bitField0_ & 0x00000020) == 0x00000020)) {
        output.writeInt32(131, errorCode_);
      }
      getUnknownFields().writeTo(output);
    }
    
    private int memoizedSerializedSize = -1;
    public int getSerializedSize() {
      int size = memoizedSerializedSize;
      if (size != -1) return size;
    
      size = 0;
      if (((bitField0_ & 0x00000001) == 0x00000001)) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt64Size(1, sourceId_);
      }
      if (((bitField0_ & 0x00000002) == 0x00000002)) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt64Size(2, messageType_);
      }
      if (((bitField0_ & 0x00000004) == 0x00000004)) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(3, messageTime_);
      }
      if (((bitField0_ & 0x00000008) == 0x00000008)) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt64Size(5, timeStamp_);
      }
      if (((bitField0_ & 0x00000010) == 0x00000010)) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(6, messageBlock_);
      }
      if (((bitField0_ & 0x00000020) == 0x00000020)) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(131, errorCode_);
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSerializedSize = size;
      return size;
    }
    
    private static final long serialVersionUID = 0L;
    @java.lang.Override
    protected java.lang.Object writeReplace()
        throws java.io.ObjectStreamException {
      return super.writeReplace();
    }
    
    public static ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateFailure parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateFailure parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data, extensionRegistry)
               .buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateFailure parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateFailure parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data, extensionRegistry)
               .buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateFailure parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateFailure parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input, extensionRegistry)
               .buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateFailure parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      Builder builder = newBuilder();
      if (builder.mergeDelimitedFrom(input)) {
        return builder.buildParsed();
      } else {
        return null;
      }
    }
    public static ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateFailure parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      Builder builder = newBuilder();
      if (builder.mergeDelimitedFrom(input, extensionRegistry)) {
        return builder.buildParsed();
      } else {
        return null;
      }
    }
    public static ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateFailure parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateFailure parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input, extensionRegistry)
               .buildParsed();
    }
    
    public static Builder newBuilder() { return Builder.create(); }
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder(ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateFailure prototype) {
      return newBuilder().mergeFrom(prototype);
    }
    public Builder toBuilder() { return newBuilder(this); }
    
    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessage.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    public static final class Builder extends
        com.google.protobuf.GeneratedMessage.Builder<Builder>
       implements ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateFailureOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return ru.omnicomm.pegasus.messaging.online.COState.COStateParser.internal_static_ru_omnicomm_pegasus_messaging_online_COState_COStateFailure_descriptor;
      }
      
      protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return ru.omnicomm.pegasus.messaging.online.COState.COStateParser.internal_static_ru_omnicomm_pegasus_messaging_online_COState_COStateFailure_fieldAccessorTable;
      }
      
      // Construct using ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateFailure.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }
      
      private Builder(BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }
      private void maybeForceBuilderInitialization() {
        if (com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders) {
        }
      }
      private static Builder create() {
        return new Builder();
      }
      
      public Builder clear() {
        super.clear();
        sourceId_ = 0L;
        bitField0_ = (bitField0_ & ~0x00000001);
        messageType_ = 0L;
        bitField0_ = (bitField0_ & ~0x00000002);
        messageTime_ = 0;
        bitField0_ = (bitField0_ & ~0x00000004);
        timeStamp_ = 0L;
        bitField0_ = (bitField0_ & ~0x00000008);
        messageBlock_ = 0;
        bitField0_ = (bitField0_ & ~0x00000010);
        errorCode_ = 0;
        bitField0_ = (bitField0_ & ~0x00000020);
        return this;
      }
      
      public Builder clone() {
        return create().mergeFrom(buildPartial());
      }
      
      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateFailure.getDescriptor();
      }
      
      public ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateFailure getDefaultInstanceForType() {
        return ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateFailure.getDefaultInstance();
      }
      
      public ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateFailure build() {
        ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateFailure result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }
      
      private ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateFailure buildParsed()
          throws com.google.protobuf.InvalidProtocolBufferException {
        ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateFailure result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(
            result).asInvalidProtocolBufferException();
        }
        return result;
      }
      
      public ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateFailure buildPartial() {
        ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateFailure result = new ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateFailure(this);
        int from_bitField0_ = bitField0_;
        int to_bitField0_ = 0;
        if (((from_bitField0_ & 0x00000001) == 0x00000001)) {
          to_bitField0_ |= 0x00000001;
        }
        result.sourceId_ = sourceId_;
        if (((from_bitField0_ & 0x00000002) == 0x00000002)) {
          to_bitField0_ |= 0x00000002;
        }
        result.messageType_ = messageType_;
        if (((from_bitField0_ & 0x00000004) == 0x00000004)) {
          to_bitField0_ |= 0x00000004;
        }
        result.messageTime_ = messageTime_;
        if (((from_bitField0_ & 0x00000008) == 0x00000008)) {
          to_bitField0_ |= 0x00000008;
        }
        result.timeStamp_ = timeStamp_;
        if (((from_bitField0_ & 0x00000010) == 0x00000010)) {
          to_bitField0_ |= 0x00000010;
        }
        result.messageBlock_ = messageBlock_;
        if (((from_bitField0_ & 0x00000020) == 0x00000020)) {
          to_bitField0_ |= 0x00000020;
        }
        result.errorCode_ = errorCode_;
        result.bitField0_ = to_bitField0_;
        onBuilt();
        return result;
      }
      
      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateFailure) {
          return mergeFrom((ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateFailure)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }
      
      public Builder mergeFrom(ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateFailure other) {
        if (other == ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateFailure.getDefaultInstance()) return this;
        if (other.hasSourceId()) {
          setSourceId(other.getSourceId());
        }
        if (other.hasMessageType()) {
          setMessageType(other.getMessageType());
        }
        if (other.hasMessageTime()) {
          setMessageTime(other.getMessageTime());
        }
        if (other.hasTimeStamp()) {
          setTimeStamp(other.getTimeStamp());
        }
        if (other.hasMessageBlock()) {
          setMessageBlock(other.getMessageBlock());
        }
        if (other.hasErrorCode()) {
          setErrorCode(other.getErrorCode());
        }
        this.mergeUnknownFields(other.getUnknownFields());
        return this;
      }
      
      public final boolean isInitialized() {
        if (!hasMessageType()) {
          
          return false;
        }
        return true;
      }
      
      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        com.google.protobuf.UnknownFieldSet.Builder unknownFields =
          com.google.protobuf.UnknownFieldSet.newBuilder(
            this.getUnknownFields());
        while (true) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              this.setUnknownFields(unknownFields.build());
              onChanged();
              return this;
            default: {
              if (!parseUnknownField(input, unknownFields,
                                     extensionRegistry, tag)) {
                this.setUnknownFields(unknownFields.build());
                onChanged();
                return this;
              }
              break;
            }
            case 8: {
              bitField0_ |= 0x00000001;
              sourceId_ = input.readInt64();
              break;
            }
            case 16: {
              bitField0_ |= 0x00000002;
              messageType_ = input.readInt64();
              break;
            }
            case 24: {
              bitField0_ |= 0x00000004;
              messageTime_ = input.readInt32();
              break;
            }
            case 40: {
              bitField0_ |= 0x00000008;
              timeStamp_ = input.readInt64();
              break;
            }
            case 48: {
              bitField0_ |= 0x00000010;
              messageBlock_ = input.readInt32();
              break;
            }
            case 1048: {
              bitField0_ |= 0x00000020;
              errorCode_ = input.readInt32();
              break;
            }
          }
        }
      }
      
      private int bitField0_;
      
      // optional int64 sourceId = 1;
      private long sourceId_ ;
      public boolean hasSourceId() {
        return ((bitField0_ & 0x00000001) == 0x00000001);
      }
      public long getSourceId() {
        return sourceId_;
      }
      public Builder setSourceId(long value) {
        bitField0_ |= 0x00000001;
        sourceId_ = value;
        onChanged();
        return this;
      }
      public Builder clearSourceId() {
        bitField0_ = (bitField0_ & ~0x00000001);
        sourceId_ = 0L;
        onChanged();
        return this;
      }
      
      // required int64 messageType = 2;
      private long messageType_ ;
      public boolean hasMessageType() {
        return ((bitField0_ & 0x00000002) == 0x00000002);
      }
      public long getMessageType() {
        return messageType_;
      }
      public Builder setMessageType(long value) {
        bitField0_ |= 0x00000002;
        messageType_ = value;
        onChanged();
        return this;
      }
      public Builder clearMessageType() {
        bitField0_ = (bitField0_ & ~0x00000002);
        messageType_ = 0L;
        onChanged();
        return this;
      }
      
      // optional int32 messageTime = 3;
      private int messageTime_ ;
      public boolean hasMessageTime() {
        return ((bitField0_ & 0x00000004) == 0x00000004);
      }
      public int getMessageTime() {
        return messageTime_;
      }
      public Builder setMessageTime(int value) {
        bitField0_ |= 0x00000004;
        messageTime_ = value;
        onChanged();
        return this;
      }
      public Builder clearMessageTime() {
        bitField0_ = (bitField0_ & ~0x00000004);
        messageTime_ = 0;
        onChanged();
        return this;
      }
      
      // optional int64 timeStamp = 5;
      private long timeStamp_ ;
      public boolean hasTimeStamp() {
        return ((bitField0_ & 0x00000008) == 0x00000008);
      }
      public long getTimeStamp() {
        return timeStamp_;
      }
      public Builder setTimeStamp(long value) {
        bitField0_ |= 0x00000008;
        timeStamp_ = value;
        onChanged();
        return this;
      }
      public Builder clearTimeStamp() {
        bitField0_ = (bitField0_ & ~0x00000008);
        timeStamp_ = 0L;
        onChanged();
        return this;
      }
      
      // optional int32 messageBlock = 6;
      private int messageBlock_ ;
      public boolean hasMessageBlock() {
        return ((bitField0_ & 0x00000010) == 0x00000010);
      }
      public int getMessageBlock() {
        return messageBlock_;
      }
      public Builder setMessageBlock(int value) {
        bitField0_ |= 0x00000010;
        messageBlock_ = value;
        onChanged();
        return this;
      }
      public Builder clearMessageBlock() {
        bitField0_ = (bitField0_ & ~0x00000010);
        messageBlock_ = 0;
        onChanged();
        return this;
      }
      
      // optional int32 errorCode = 131;
      private int errorCode_ ;
      public boolean hasErrorCode() {
        return ((bitField0_ & 0x00000020) == 0x00000020);
      }
      public int getErrorCode() {
        return errorCode_;
      }
      public Builder setErrorCode(int value) {
        bitField0_ |= 0x00000020;
        errorCode_ = value;
        onChanged();
        return this;
      }
      public Builder clearErrorCode() {
        bitField0_ = (bitField0_ & ~0x00000020);
        errorCode_ = 0;
        onChanged();
        return this;
      }
      
      // @@protoc_insertion_point(builder_scope:ru.omnicomm.pegasus.messaging.online.COState.COStateFailure)
    }
    
    static {
      defaultInstance = new COStateFailure(true);
      defaultInstance.initFields();
    }
    
    // @@protoc_insertion_point(class_scope:ru.omnicomm.pegasus.messaging.online.COState.COStateFailure)
  }
  
  private static com.google.protobuf.Descriptors.Descriptor
    internal_static_ru_omnicomm_pegasus_messaging_online_COState_COStateON_descriptor;
  private static
    com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internal_static_ru_omnicomm_pegasus_messaging_online_COState_COStateON_fieldAccessorTable;
  private static com.google.protobuf.Descriptors.Descriptor
    internal_static_ru_omnicomm_pegasus_messaging_online_COState_COStateOFF_descriptor;
  private static
    com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internal_static_ru_omnicomm_pegasus_messaging_online_COState_COStateOFF_fieldAccessorTable;
  private static com.google.protobuf.Descriptors.Descriptor
    internal_static_ru_omnicomm_pegasus_messaging_online_COState_COStateFailure_descriptor;
  private static
    com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internal_static_ru_omnicomm_pegasus_messaging_online_COState_COStateFailure_fieldAccessorTable;
  
  public static com.google.protobuf.Descriptors.FileDescriptor
      getDescriptor() {
    return descriptor;
  }
  private static com.google.protobuf.Descriptors.FileDescriptor
      descriptor;
  static {
    java.lang.String[] descriptorData = {
      "\n\rCOState.proto\022,ru.omnicomm.pegasus.mes" +
      "saging.online.COState\"\203\001\n\tCOStateON\022\020\n\010s" +
      "ourceId\030\001 \001(\003\022\023\n\013messageType\030\002 \002(\003\022\023\n\013me" +
      "ssageTime\030\003 \001(\005\022\021\n\ttimeStamp\030\005 \001(\003\022\024\n\014me" +
      "ssageBlock\030\006 \001(\005\022\021\n\010stateIds\030\202\001 \003(\005\"\204\001\n\n" +
      "COStateOFF\022\020\n\010sourceId\030\001 \001(\003\022\023\n\013messageT" +
      "ype\030\002 \002(\003\022\023\n\013messageTime\030\003 \001(\005\022\021\n\ttimeSt" +
      "amp\030\005 \001(\003\022\024\n\014messageBlock\030\006 \001(\005\022\021\n\010state" +
      "Ids\030\202\001 \003(\005\"\211\001\n\016COStateFailure\022\020\n\010sourceI" +
      "d\030\001 \001(\003\022\023\n\013messageType\030\002 \002(\003\022\023\n\013messageT",
      "ime\030\003 \001(\005\022\021\n\ttimeStamp\030\005 \001(\003\022\024\n\014messageB" +
      "lock\030\006 \001(\005\022\022\n\terrorCode\030\203\001 \001(\005B=\n,ru.omn" +
      "icomm.pegasus.messaging.online.COStateB\r" +
      "COStateParser"
    };
    com.google.protobuf.Descriptors.FileDescriptor.InternalDescriptorAssigner assigner =
      new com.google.protobuf.Descriptors.FileDescriptor.InternalDescriptorAssigner() {
        public com.google.protobuf.ExtensionRegistry assignDescriptors(
            com.google.protobuf.Descriptors.FileDescriptor root) {
          descriptor = root;
          internal_static_ru_omnicomm_pegasus_messaging_online_COState_COStateON_descriptor =
            getDescriptor().getMessageTypes().get(0);
          internal_static_ru_omnicomm_pegasus_messaging_online_COState_COStateON_fieldAccessorTable = new
            com.google.protobuf.GeneratedMessage.FieldAccessorTable(
              internal_static_ru_omnicomm_pegasus_messaging_online_COState_COStateON_descriptor,
              new java.lang.String[] { "SourceId", "MessageType", "MessageTime", "TimeStamp", "MessageBlock", "StateIds", },
              ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateON.class,
              ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateON.Builder.class);
          internal_static_ru_omnicomm_pegasus_messaging_online_COState_COStateOFF_descriptor =
            getDescriptor().getMessageTypes().get(1);
          internal_static_ru_omnicomm_pegasus_messaging_online_COState_COStateOFF_fieldAccessorTable = new
            com.google.protobuf.GeneratedMessage.FieldAccessorTable(
              internal_static_ru_omnicomm_pegasus_messaging_online_COState_COStateOFF_descriptor,
              new java.lang.String[] { "SourceId", "MessageType", "MessageTime", "TimeStamp", "MessageBlock", "StateIds", },
              ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateOFF.class,
              ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateOFF.Builder.class);
          internal_static_ru_omnicomm_pegasus_messaging_online_COState_COStateFailure_descriptor =
            getDescriptor().getMessageTypes().get(2);
          internal_static_ru_omnicomm_pegasus_messaging_online_COState_COStateFailure_fieldAccessorTable = new
            com.google.protobuf.GeneratedMessage.FieldAccessorTable(
              internal_static_ru_omnicomm_pegasus_messaging_online_COState_COStateFailure_descriptor,
              new java.lang.String[] { "SourceId", "MessageType", "MessageTime", "TimeStamp", "MessageBlock", "ErrorCode", },
              ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateFailure.class,
              ru.omnicomm.pegasus.messaging.online.COState.COStateParser.COStateFailure.Builder.class);
          return null;
        }
      };
    com.google.protobuf.Descriptors.FileDescriptor
      .internalBuildGeneratedFileFrom(descriptorData,
        new com.google.protobuf.Descriptors.FileDescriptor[] {
        }, assigner);
  }
  
  // @@protoc_insertion_point(outer_class_scope)
}
